/*                                                          */
/* File generated by "DeZign for databases"                 */
/* Create-date    :7/25/2001                                */
/* Create-time    :3:45:07 PM                               */
/* project-name   :Not yet specified                        */
/* project-author :Not yet specified                        */
/*                                                          */


CREATE TABLE aguser(
id serial NOT NULL UNIQUE PRIMARY KEY,
login text NOT NULL,
password text,
realname text,
institution text,
email text,
phone text);


CREATE TABLE channel(
id serial NOT NULL PRIMARY KEY,
address text,
port int4,
ttl int2,
bandwidth int4,
media text,
format int2);


CREATE TABLE channel_key(
id serial NOT NULL PRIMARY KEY,
encryption_key text);


CREATE TABLE phplib_active_sessions(
sid varchar(32) DEFAULT '' NOT NULL,
name varchar(32) DEFAULT '' NOT NULL,
val text,
changed varchar(14) DEFAULT '' NOT NULL,
PRIMARY KEY (sid,name));

COMMENT ON TABLE phplib_active_sessions IS 'PHPLIB support: active sessions table.';
CREATE INDEX k_changed ON phplib_active_sessions (changed);

CREATE TABLE room(
id serial NOT NULL PRIMARY KEY,
name text,
description text);


CREATE TABLE exit(
id serial NOT NULL PRIMARY KEY,
dest int4 NOT NULL,
source int4 NOT NULL,
FOREIGN KEY (source) REFERENCES room (id),
FOREIGN KEY (dest) REFERENCES room (id));


CREATE TABLE voyager_url(
url text,
room_id int4,
FOREIGN KEY (room_id) REFERENCES room (id));


CREATE TABLE voyager_user(
user_id int4,
FOREIGN KEY (user_id) REFERENCES aguser (id));


CREATE TABLE mud(
id serial NOT NULL PRIMARY KEY,
name text,
host text,
port int4);


CREATE TABLE channel_channel_key(
channel_key_id int4,
channel_id int4,
FOREIGN KEY (channel_id) REFERENCES channel (id),
FOREIGN KEY (channel_key_id) REFERENCES channel_key (id),
PRIMARY KEY (channel_key_id,channel_id));


CREATE TABLE room_channel(
channel_id int4,
room_id int4,
FOREIGN KEY (channel_id) REFERENCES channel (id),
FOREIGN KEY (room_id) REFERENCES room (id),
PRIMARY KEY (channel_id,room_id));


CREATE TABLE default_entry_room(
room_id int4 NOT NULL PRIMARY KEY,
FOREIGN KEY (room_id) REFERENCES room (id));


CREATE TABLE acl(
id serial NOT NULL UNIQUE PRIMARY KEY,
name text,
expires date);

COMMENT ON TABLE acl IS 'An ACL is a list of ACL entries with an expiration date. Each entry has a user id and status.';

CREATE TABLE acl_entry(
id serial NOT NULL UNIQUE PRIMARY KEY,
has_access bool DEFAULT true NOT NULL,
acl int4 NOT NULL,
user_id int4 NOT NULL,
FOREIGN KEY (acl) REFERENCES acl (id),
FOREIGN KEY (user_id) REFERENCES aguser (id));


CREATE TABLE room_acl(
room_id int4,
acl_id int4,
FOREIGN KEY (room_id) REFERENCES acl (id),
FOREIGN KEY (acl_id) REFERENCES room (id),
PRIMARY KEY (room_id,acl_id));


CREATE TABLE mud_room(
mud_room_object_id text,
mud_id int4 NOT NULL,
room_id int4 NOT NULL,
FOREIGN KEY (mud_id) REFERENCES mud (id),
FOREIGN KEY (room_id) REFERENCES room (id));


CREATE TABLE authorization(
auth_type text NOT NULL UNIQUE PRIMARY KEY);


CREATE TABLE aguser_authorization(
auth_type text,
user_id int4,
FOREIGN KEY (user_id) REFERENCES aguser (id),
FOREIGN KEY (auth_type) REFERENCES authorization (auth_type),
PRIMARY KEY (auth_type,user_id));


CREATE TABLE room_admin(
room_id int4,
user_id int4,
FOREIGN KEY (user_id) REFERENCES aguser (id),
FOREIGN KEY (room_id) REFERENCES room (id),
PRIMARY KEY (room_id,user_id));


CREATE TABLE acl_channel_entry(
acl_id int4 NOT NULL,
encryption_key text,
channel_id int4 NOT NULL,
FOREIGN KEY (acl_id) REFERENCES acl (id),
FOREIGN KEY (channel_id) REFERENCES channel (id));


CREATE TABLE mud_char(
mud_character text,
mud_password text,
user_id int4,
mud_id int4 NOT NULL,
FOREIGN KEY (user_id) REFERENCES aguser (id),
FOREIGN KEY (mud_id) REFERENCES mud (id));


CREATE TABLE remote_exit(
id serial NOT NULL PRIMARY KEY,
name text,
remote_link text,
room_id int4 NOT NULL,
FOREIGN KEY (room_id) REFERENCES room (id));

CREATE TABLE booking(
id serial NOT NULL PRIMARY KEY,
description text,
room_id int4 NOT NULL,
user_id int4 NOT NULL,
FOREIGN KEY (room_id) REFERENCES room (id),
FOREIGN KEY (user_id) REFERENCES aguser (id),
start_time  timestamp NOT NULL,
duration    interval  NOT NULL);
